from log import log


class Rules(list):
    def __init__(self, rules=None):
        super().__init__()
        self.rule_set = set()
        if rules is not None:
            for rule in rules:
                if rule in self.rule_set:
                    log.warning('duplicate rule %s', rule)
                else:
                    self.append(rule)
                    self.rule_set.add(rule)
